package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.WFUserCandidateMapper;
import com.sa.ibiz.demo.demo.domain.WFUserCandidate;
import com.sa.ibiz.demo.demo.service.WFUserCandidateService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.WFUserCandidateSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.WFUserService;
import com.sa.ibiz.demo.demo.service.WFUserService;

/**
 * 实体[WFUserCandidate] 服务对象接口实现
 */
@Service
public class WFUserCandidateServiceImpl extends ServiceImplBase<WFUserCandidateMapper, WFUserCandidate> implements WFUserCandidateService{

    @Autowired
    private WFUserService wfmajoruserService;
    @Autowired
    private WFUserService wfminoruserService;

    @Resource
    private WFUserCandidateMapper wfusercandidateMapper;


    @Override
    public boolean create(WFUserCandidate et) {
        this.beforeCreate(et);
         return super.create(et);
    }
    @Override
    public boolean update(WFUserCandidate et){
        this.beforeUpdate(et);
		this.wfusercandidateMapper.updateOne(et);
		this.get(et);
		return true;
    }

    public Object getEntityKey(WFUserCandidate et){
		return et.getWfusercandidateid();  
    }

    @Override
    public boolean getDraft(WFUserCandidate et)  {
    if((!StringUtils.isEmpty(et.getWfmajoruserid())) && et.getWfmajoruser() == null){
            try {
                et.setWfmajoruser(wfmajoruserService.getById(et.getWfmajoruserid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getWfminoruserid())) && et.getWfminoruser() == null){
            try {
                et.setWfminoruser(wfminoruserService.getById(et.getWfminoruserid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<WFUserCandidate> listDefault(WFUserCandidateSearchFilter filter) {
		return wfusercandidateMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<WFUserCandidate> searchDefault(WFUserCandidateSearchFilter filter) {
		return wfusercandidateMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return wfusercandidateMapper.selectRow(sql);
    }

 }